// AdvancedInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PEEditor.h"
#include "AdvancedInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdvancedInfoDlg dialog


CAdvancedInfoDlg::CAdvancedInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAdvancedInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdvancedInfoDlg)
	//}}AFX_DATA_INIT
}


void CAdvancedInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvancedInfoDlg)
	DDX_Control(pDX, IDC_STAMP, m_18);
	DDX_Control(pDX, IDC_SIZE_OF_UD, m_17);
	DDX_Control(pDX, IDC_SIZE_OF_ID, m_16);
	DDX_Control(pDX, IDC_SIZE_OF_CODE, m_15);
	DDX_Control(pDX, IDC_RESERVE_SS, m_14);
	DDX_Control(pDX, IDC_RESERVE_SH, m_13);
	DDX_Control(pDX, IDC_OBJ_ALIGN, m_12);
	DDX_Control(pDX, IDC_NT_F_S, m_11);
	DDX_Control(pDX, IDC_MAGIC, m_10);
	DDX_Control(pDX, IDC_LOADER_FLAGS, m_9);
	DDX_Control(pDX, IDC_HEADER_SIZE, m_8);
	DDX_Control(pDX, IDC_FILE_ALIGN, m_7);
	DDX_Control(pDX, IDC_DLL_FLAGS, m_6);
	DDX_Control(pDX, IDC_CRC, m_5);
	DDX_Control(pDX, IDC_COMMIT_SS, m_4);
	DDX_Control(pDX, IDC_COMMIT_SH, m_3);
	DDX_Control(pDX, IDC_BASE_OF_DATA, m_2);
	DDX_Control(pDX, IDC_BASE_OF_CODE, m_1);
	DDX_Control(pDX, IDC_LNK_MAJOR, m_v8);
	DDX_Control(pDX, IDC_LNK_MINOR, m_v7);
	DDX_Control(pDX, IDC_OS_MAJOR, m_v6);
	DDX_Control(pDX, IDC_OS_MINOR, m_v5);
	DDX_Control(pDX, IDC_SUB_MAJOR, m_v4);
	DDX_Control(pDX, IDC_SUB_MINOR, m_v3);
	DDX_Control(pDX, IDC_USER_MAJOR, m_v2);
	DDX_Control(pDX, IDC_USER_MINOR, m_v1);
	DDX_Control(pDX, IDC_P_TO_COFF, m_PC);
	DDX_Control(pDX, IDC_COFF_SIZE, m_CS);
	DDX_Control(pDX, IDC_SUBSYS_FLAGS, m_SSFlags);
	DDX_Control(pDX, IDC_CPU_TYPE, m_CPUType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvancedInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CAdvancedInfoDlg)
	ON_BN_CLICKED(ID_OK, OnOk)
	ON_BN_CLICKED(ID_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdvancedInfoDlg message handlers

BOOL CAdvancedInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_CS.SetLimitText(8);
	m_PC.SetLimitText(8);

	m_v1.SetLimitText(2);
	m_v2.SetLimitText(2);
	m_v3.SetLimitText(2);
	m_v4.SetLimitText(2);
	m_v5.SetLimitText(2);
	m_v6.SetLimitText(2);
	m_v7.SetLimitText(2);
	m_v8.SetLimitText(2);

	m_1.SetLimitText(8);
	m_2.SetLimitText(8);
	m_3.SetLimitText(8);
	m_4.SetLimitText(8);
	m_5.SetLimitText(8);
	m_6.SetLimitText(8);
	m_7.SetLimitText(8);
	m_8.SetLimitText(8);
	m_9.SetLimitText(8);
	m_10.SetLimitText(8);
	m_11.SetLimitText(8);
	m_12.SetLimitText(8);
	m_13.SetLimitText(8);
	m_14.SetLimitText(8);
	m_15.SetLimitText(8);
	m_16.SetLimitText(8);
	m_17.SetLimitText(8);
	m_18.SetLimitText(8);


	switch(m_PEFile.PEHdr.SubSystem)
	{
		case 0x0000:
			m_SSFlags.SetCurSel(0);
			break;
		case 0x0001:
			m_SSFlags.SetCurSel(1);
			break;
		case 0x0002:
			m_SSFlags.SetCurSel(2);
			break;
		case 0x0003:
			m_SSFlags.SetCurSel(3);
			break;
		case 0x0005:
			m_SSFlags.SetCurSel(4);
			break;
		case 0x0007:
			m_SSFlags.SetCurSel(5);
			break;
	}

	switch(m_PEFile.PEHdr.CPUType)
	{
		case 0x0000:
			m_CPUType.SetCurSel(0);
			break;
		case 0x014C:
			m_CPUType.SetCurSel(1);
			break;
		case 0x0162:
			m_CPUType.SetCurSel(2);
			break;
		case 0x0166:
			m_CPUType.SetCurSel(3);
			break;
		case 0x0168:
			m_CPUType.SetCurSel(4);
			break;
		case 0x0169:
			m_CPUType.SetCurSel(5);
			break;
		case 0x0184:
			m_CPUType.SetCurSel(6);
			break;
		case 0x01F0:
			m_CPUType.SetCurSel(7);
			break;
		case 0x01A2:
			m_CPUType.SetCurSel(8);
			break;
		case 0x01A4:
			m_CPUType.SetCurSel(9);
			break;
		case 0x01A6:
			m_CPUType.SetCurSel(10);
			break;
		case 0x01C0:
			m_CPUType.SetCurSel(11);
			break;
		case 0x01C2:
			m_CPUType.SetCurSel(12);
			break;
		case 0x0200:
			m_CPUType.SetCurSel(13);
			break;
		case 0x0266:
			m_CPUType.SetCurSel(14);
			break;
		case 0x0366:
			m_CPUType.SetCurSel(15);
			break;
		case 0x0466:
			m_CPUType.SetCurSel(16);
			break;
		case 0x0284:
			m_CPUType.SetCurSel(17);
			break;
	}

	SetDlgItemInt(IDC_LNK_MAJOR, m_PEFile.PEHdr.LinkMajor);
	SetDlgItemInt(IDC_LNK_MINOR, m_PEFile.PEHdr.LinkMinor);
	SetDlgItemInt(IDC_OS_MAJOR,  m_PEFile.PEHdr.OSMajor);
	SetDlgItemInt(IDC_OS_MINOR,  m_PEFile.PEHdr.OSMinor);
	SetDlgItemInt(IDC_USER_MAJOR,m_PEFile.PEHdr.USERMajor);
	SetDlgItemInt(IDC_USER_MINOR,m_PEFile.PEHdr.USERMinor);
	SetDlgItemInt(IDC_SUB_MAJOR, m_PEFile.PEHdr.SubSysMajor);
	SetDlgItemInt(IDC_SUB_MINOR, m_PEFile.PEHdr.SubSysMinor);
	
	SetDlgItemText(IDC_P_TO_COFF, ConvToHEXStr(m_PEFile.PEHdr.PointerToCOFF));
	SetDlgItemText(IDC_COFF_SIZE, ConvToHEXStr(m_PEFile.PEHdr.COFFTableSize));
	SetDlgItemText(IDC_CRC, ConvToHEXStr(m_PEFile.PEHdr.FileChecksum));
	SetDlgItemText(IDC_RESERVE_SS, ConvToHEXStr(m_PEFile.PEHdr.StackReserveSize));
	SetDlgItemText(IDC_COMMIT_SS, ConvToHEXStr(m_PEFile.PEHdr.StackCommitSize));
	SetDlgItemText(IDC_RESERVE_SH, ConvToHEXStr(m_PEFile.PEHdr.HeapReserveSize));
	SetDlgItemText(IDC_COMMIT_SH, ConvToHEXStr(m_PEFile.PEHdr.HeapComitSize));
	SetDlgItemText(IDC_STAMP, ConvToHEXStr(m_PEFile.PEHdr.TimeDateStamp));
	SetDlgItemText(IDC_NT_F_S, ConvToHEXStr(m_PEFile.PEHdr.NTHeaderSize));
	SetDlgItemText(IDC_MAGIC, ConvToHEXStr(m_PEFile.PEHdr.Magic));
	SetDlgItemText(IDC_SIZE_OF_ID, ConvToHEXStr(m_PEFile.PEHdr.SizeOfInitData));
	SetDlgItemText(IDC_SIZE_OF_UD, ConvToHEXStr(m_PEFile.PEHdr.SizeOfUnInitData));
	SetDlgItemText(IDC_SIZE_OF_CODE, ConvToHEXStr(m_PEFile.PEHdr.SizeOfCode));
	SetDlgItemText(IDC_BASE_OF_CODE, ConvToHEXStr(m_PEFile.PEHdr.BaseOfCode));
	SetDlgItemText(IDC_BASE_OF_DATA, ConvToHEXStr(m_PEFile.PEHdr.BaseOfData));
	SetDlgItemText(IDC_FILE_ALIGN, ConvToHEXStr(m_PEFile.PEHdr.FileAlign));
	SetDlgItemText(IDC_OBJ_ALIGN, ConvToHEXStr(m_PEFile.PEHdr.ObjectAlign));
	SetDlgItemText(IDC_DLL_FLAGS, ConvToHEXStr(m_PEFile.PEHdr.DLLFlags));
	SetDlgItemText(IDC_LOADER_FLAGS, ConvToHEXStr(m_PEFile.PEHdr.LoaderFlags));
	SetDlgItemText(IDC_HEADER_SIZE, ConvToHEXStr(m_PEFile.PEHdr.HeaderSize));
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAdvancedInfoDlg::OnOk() 
{
	CString tmp;
	if((MessageBox("Save advanced informations?", "Advanced Information", MB_YESNO | MB_ICONQUESTION)) == IDYES)
	{
			m_PEFile.PEHdr.LinkMajor =   GetDlgItemInt(IDC_LNK_MAJOR);
	        m_PEFile.PEHdr.LinkMinor =   GetDlgItemInt(IDC_LNK_MINOR);
	        m_PEFile.PEHdr.OSMajor =     GetDlgItemInt(IDC_OS_MAJOR);
	        m_PEFile.PEHdr.OSMinor =     GetDlgItemInt(IDC_OS_MINOR);
	        m_PEFile.PEHdr.USERMajor =   GetDlgItemInt(IDC_USER_MAJOR);
	        m_PEFile.PEHdr.USERMinor =   GetDlgItemInt(IDC_USER_MINOR);
        	m_PEFile.PEHdr.SubSysMajor = GetDlgItemInt(IDC_SUB_MAJOR);
	        m_PEFile.PEHdr.SubSysMinor = GetDlgItemInt(IDC_SUB_MINOR);

			GetDlgItemText(IDC_COFF_SIZE, tmp);
			m_PEFile.PEHdr.COFFTableSize = ConvFromHex(tmp);
			GetDlgItemText(IDC_P_TO_COFF, tmp);
			m_PEFile.PEHdr.PointerToCOFF = ConvFromHex(tmp);
			GetDlgItemText(IDC_CRC, tmp);
			m_PEFile.PEHdr.FileChecksum = ConvFromHex(tmp);
			GetDlgItemText(IDC_RESERVE_SS, tmp);
			m_PEFile.PEHdr.StackReserveSize = ConvFromHex(tmp);
			GetDlgItemText(IDC_COMMIT_SS, tmp);
			m_PEFile.PEHdr.StackCommitSize = ConvFromHex(tmp);
			GetDlgItemText(IDC_RESERVE_SH, tmp);
			m_PEFile.PEHdr.HeapReserveSize = ConvFromHex(tmp);
			GetDlgItemText(IDC_COMMIT_SH, tmp);
			m_PEFile.PEHdr.HeapComitSize = ConvFromHex(tmp);
			GetDlgItemText(IDC_STAMP, tmp);
			m_PEFile.PEHdr.TimeDateStamp = ConvFromHex(tmp);
			GetDlgItemText(IDC_NT_F_S, tmp);
			m_PEFile.PEHdr.NTHeaderSize = (WORD)ConvFromHex(tmp);
			GetDlgItemText(IDC_MAGIC, tmp);
			m_PEFile.PEHdr.Magic = (WORD)ConvFromHex(tmp);
			GetDlgItemText(IDC_SIZE_OF_ID, tmp);
			m_PEFile.PEHdr.SizeOfInitData = ConvFromHex(tmp);
			GetDlgItemText(IDC_SIZE_OF_UD, tmp);
			m_PEFile.PEHdr.SizeOfUnInitData = ConvFromHex(tmp);
			GetDlgItemText(IDC_SIZE_OF_CODE, tmp);
			m_PEFile.PEHdr.SizeOfCode = ConvFromHex(tmp);
			GetDlgItemText(IDC_BASE_OF_CODE, tmp);
			m_PEFile.PEHdr.BaseOfCode = ConvFromHex(tmp);
			GetDlgItemText(IDC_BASE_OF_DATA, tmp);
			m_PEFile.PEHdr.BaseOfData = ConvFromHex(tmp);
			GetDlgItemText(IDC_FILE_ALIGN, tmp);
			m_PEFile.PEHdr.FileAlign = ConvFromHex(tmp);
			GetDlgItemText(IDC_OBJ_ALIGN, tmp);
			m_PEFile.PEHdr.ObjectAlign = ConvFromHex(tmp);
			GetDlgItemText(IDC_DLL_FLAGS, tmp);
			m_PEFile.PEHdr.DLLFlags = (WORD)ConvFromHex(tmp);
			GetDlgItemText(IDC_LOADER_FLAGS, tmp);
			m_PEFile.PEHdr.LoaderFlags = ConvFromHex(tmp);
			GetDlgItemText(IDC_HEADER_SIZE, tmp);
			m_PEFile.PEHdr.HeaderSize = ConvFromHex(tmp);

		switch(m_SSFlags.GetCurSel())
		{
		case 0:
			m_PEFile.PEHdr.SubSystem = 0x0000;
			break;
		case 1:
			m_PEFile.PEHdr.SubSystem = 0x0001;
			break;
		case 2:
			m_PEFile.PEHdr.SubSystem = 0x0002;
			break;
		case 3:
			m_PEFile.PEHdr.SubSystem = 0x0003;
			break;
		case 4:
			m_PEFile.PEHdr.SubSystem = 0x0005;
			break;
		case 5:
			m_PEFile.PEHdr.SubSystem = 0x0007;
			break;
		case 6:
			m_PEFile.PEHdr.SubSystem = 0x0166;
			break;
		}

	switch(m_CPUType.GetCurSel())
	{
		case 0:
			m_PEFile.PEHdr.CPUType = 0x0000;
			break;
		case 1:
			m_PEFile.PEHdr.CPUType = 0x014C;
			break;
		case 2:
			m_PEFile.PEHdr.CPUType = 0x0162;
			break;
		case 3:
			m_PEFile.PEHdr.CPUType = 0x0166;
			break;
		case 4:
			m_PEFile.PEHdr.CPUType = 0x0168;
			break;
		case 5:
			m_PEFile.PEHdr.CPUType = 0x0169;
			break;
		case 6:
			m_PEFile.PEHdr.CPUType = 0x0184;
			break;
		case 7:
			m_PEFile.PEHdr.CPUType = 0x01F0;
			break;
		case 8:
			m_PEFile.PEHdr.CPUType = 0x01A2;
			break;
		case 9:
			m_PEFile.PEHdr.CPUType = 0x01A4;
			break;
		case 10:
			m_PEFile.PEHdr.CPUType = 0x01A6;
			break;
		case 11:
			m_PEFile.PEHdr.CPUType = 0x01C0;
			break;
		case 12:
			m_PEFile.PEHdr.CPUType = 0x01C2;
			break;
		case 13:
			m_PEFile.PEHdr.CPUType = 0x0200;
			break;
		case 14:
			m_PEFile.PEHdr.CPUType = 0x0266;
			break;
		case 15:
			m_PEFile.PEHdr.CPUType = 0x0366;
			break;
		case 16:
			m_PEFile.PEHdr.CPUType = 0x0466;
			break;
		case 17:
			m_PEFile.PEHdr.CPUType = 0x0284;
			break;
	}

	       m_PEFile.WritePEHeader();
		   CDialog::OnOK();

	}else CDialog::OnOK();
}

void CAdvancedInfoDlg::OnCancel() 
{
	CDialog::OnCancel();
}
