// DirectoryInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PEEditor.h"
#include "DirectoryInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDirectoryInfoDlg dialog


CDirectoryInfoDlg::CDirectoryInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDirectoryInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDirectoryInfoDlg)
	//}}AFX_DATA_INIT
}


void CDirectoryInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDirectoryInfoDlg)
	DDX_Control(pDX, IDC_DATA9, m_D9);
	DDX_Control(pDX, IDC_DATA8, m_D8);
	DDX_Control(pDX, IDC_DATA7, m_D7);
	DDX_Control(pDX, IDC_DATA6, m_D6);
	DDX_Control(pDX, IDC_DATA5, m_D5);
	DDX_Control(pDX, IDC_DATA4, m_D4);
	DDX_Control(pDX, IDC_DATA3, m_D3);
	DDX_Control(pDX, IDC_DATA24, m_D24);
	DDX_Control(pDX, IDC_DATA23, m_D23);
	DDX_Control(pDX, IDC_DATA22, m_D22);
	DDX_Control(pDX, IDC_DATA21, m_D21);
	DDX_Control(pDX, IDC_DATA20, m_D20);
	DDX_Control(pDX, IDC_DATA2, m_D2);
	DDX_Control(pDX, IDC_DATA19, m_D19);
	DDX_Control(pDX, IDC_DATA18, m_D18);
	DDX_Control(pDX, IDC_DATA17, m_D17);
	DDX_Control(pDX, IDC_DATA16, m_D16);
	DDX_Control(pDX, IDC_DATA15, m_D15);
	DDX_Control(pDX, IDC_DATA14, m_D14);
	DDX_Control(pDX, IDC_DATA13, m_D13);
	DDX_Control(pDX, IDC_DATA12, m_D12);
	DDX_Control(pDX, IDC_DATA11, m_D11);
	DDX_Control(pDX, IDC_DATA10, m_D10);
	DDX_Control(pDX, IDC_DATA1, m_D1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDirectoryInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CDirectoryInfoDlg)
	ON_BN_CLICKED(ID_CANCEL, OnCancel)
	ON_BN_CLICKED(ID_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDirectoryInfoDlg message handlers

BOOL CDirectoryInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetDlgItemText(IDC_DATA1, ConvToHEXStr(m_PEFile.PEHdr.ExportTableRVA));
	SetDlgItemText(IDC_DATA2, ConvToHEXStr(m_PEFile.PEHdr.ExportDataSize));

	SetDlgItemText(IDC_DATA3, ConvToHEXStr(m_PEFile.PEHdr.ImportTableRVA));
	SetDlgItemText(IDC_DATA4, ConvToHEXStr(m_PEFile.PEHdr.ImportDataSize));

	SetDlgItemText(IDC_DATA5, ConvToHEXStr(m_PEFile.PEHdr.ResourceTableRVA));
	SetDlgItemText(IDC_DATA6, ConvToHEXStr(m_PEFile.PEHdr.ResourceDataSize));

	SetDlgItemText(IDC_DATA7, ConvToHEXStr(m_PEFile.PEHdr.SecurityTableRVA));
	SetDlgItemText(IDC_DATA8, ConvToHEXStr(m_PEFile.PEHdr.SecurityDataSize));

	SetDlgItemText(IDC_DATA9, ConvToHEXStr(m_PEFile.PEHdr.TLSRVA));
	SetDlgItemText(IDC_DATA10, ConvToHEXStr(m_PEFile.PEHdr.TLSDataSize));

	SetDlgItemText(IDC_DATA11, ConvToHEXStr(m_PEFile.PEHdr.LoadConfigRVA));
	SetDlgItemText(IDC_DATA12, ConvToHEXStr(m_PEFile.PEHdr.LoadConfigDataSize));

	SetDlgItemText(IDC_DATA13, ConvToHEXStr(m_PEFile.PEHdr.DebugTableRVA));
	SetDlgItemText(IDC_DATA14, ConvToHEXStr(m_PEFile.PEHdr.DebugDataSize));

	SetDlgItemText(IDC_DATA15, ConvToHEXStr(m_PEFile.PEHdr.ExceptionTableRVA));
	SetDlgItemText(IDC_DATA16, ConvToHEXStr(m_PEFile.PEHdr.ExceptionDataSize));

	SetDlgItemText(IDC_DATA17, ConvToHEXStr(m_PEFile.PEHdr.FixUpTableRVA));
	SetDlgItemText(IDC_DATA18, ConvToHEXStr(m_PEFile.PEHdr.FixUpDataSize));

	SetDlgItemText(IDC_DATA19, ConvToHEXStr(m_PEFile.PEHdr.IATRVA));
	SetDlgItemText(IDC_DATA20, ConvToHEXStr(m_PEFile.PEHdr.IATDataSize));

	SetDlgItemText(IDC_DATA21, ConvToHEXStr(m_PEFile.PEHdr.ImageDescriptionRVA));
	SetDlgItemText(IDC_DATA22, ConvToHEXStr(m_PEFile.PEHdr.DescriptionDataSize));

	SetDlgItemText(IDC_DATA23, ConvToHEXStr(m_PEFile.PEHdr.MachineSpecificRVA));
	SetDlgItemText(IDC_DATA24, ConvToHEXStr(m_PEFile.PEHdr.MachnineDataSize));
	

	m_D1.SetLimitText(8);
	m_D2.SetLimitText(8);
	m_D3.SetLimitText(8);
	m_D4.SetLimitText(8);
	m_D5.SetLimitText(8);
	m_D6.SetLimitText(8);
	m_D7.SetLimitText(8);
	m_D8.SetLimitText(8);
	m_D9.SetLimitText(8);
	m_D10.SetLimitText(8);
	m_D11.SetLimitText(8);
	m_D12.SetLimitText(8);
	m_D13.SetLimitText(8);
	m_D14.SetLimitText(8);
	m_D15.SetLimitText(8);
	m_D16.SetLimitText(8);
	m_D17.SetLimitText(8);
	m_D18.SetLimitText(8);
	m_D19.SetLimitText(8);
	m_D20.SetLimitText(8);
	m_D21.SetLimitText(8);
	m_D22.SetLimitText(8);
	m_D23.SetLimitText(8);
	m_D24.SetLimitText(8);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDirectoryInfoDlg::OnOk() 
{
	if((MessageBox("Save directory informations?", "Directory Editor", MB_YESNO | MB_ICONQUESTION)) == IDYES)
	{
		CString RVA, Size;
	    CString RVA2, Size2;
	    CString RVA3, Size3;
	    CString RVA4, Size4;
	    CString RVA5, Size5;
	    CString RVA6, Size6;
	    CString RVA7, Size7;
	    CString RVA8, Size8;
	    CString RVA9, Size9;
	    CString RVA10, Size10;
	    CString RVA11, Size11;
	    CString RVA12, Size12;

    	GetDlgItemText(IDC_DATA1, RVA);
	    GetDlgItemText(IDC_DATA2, Size);
	    GetDlgItemText(IDC_DATA3, RVA2);
	    GetDlgItemText(IDC_DATA4, Size2);
	    GetDlgItemText(IDC_DATA5, RVA3);
	    GetDlgItemText(IDC_DATA6, Size3);
	    GetDlgItemText(IDC_DATA7, RVA4);
	    GetDlgItemText(IDC_DATA8, Size4);
	    GetDlgItemText(IDC_DATA9, RVA5);
	    GetDlgItemText(IDC_DATA10, Size5);
	    GetDlgItemText(IDC_DATA11, RVA6);
	    GetDlgItemText(IDC_DATA12, Size6);
	    GetDlgItemText(IDC_DATA13, RVA7);
	    GetDlgItemText(IDC_DATA14, Size7);
	    GetDlgItemText(IDC_DATA15, RVA8);
	    GetDlgItemText(IDC_DATA16, Size8);
	    GetDlgItemText(IDC_DATA17, RVA9);
	    GetDlgItemText(IDC_DATA18, Size9);
	    GetDlgItemText(IDC_DATA19, RVA10);
	    GetDlgItemText(IDC_DATA20, Size10);
	    GetDlgItemText(IDC_DATA21, RVA11);
	    GetDlgItemText(IDC_DATA22, Size11);
	    GetDlgItemText(IDC_DATA23, RVA12);
	    GetDlgItemText(IDC_DATA24, Size12);

		m_PEFile.PEHdr.ExportTableRVA  = ConvFromHex(RVA);
	    m_PEFile.PEHdr.ExportDataSize = ConvFromHex(Size);
	    m_PEFile.PEHdr.ImportTableRVA = ConvFromHex(RVA2);
	    m_PEFile.PEHdr.ImportDataSize = ConvFromHex(Size2);
	    m_PEFile.PEHdr.ResourceTableRVA = ConvFromHex(RVA3);
	    m_PEFile.PEHdr.ResourceDataSize = ConvFromHex(Size3);
	    m_PEFile.PEHdr.SecurityTableRVA = ConvFromHex(RVA4);
	    m_PEFile.PEHdr.SecurityDataSize = ConvFromHex(Size4);
	    m_PEFile.PEHdr.TLSRVA = ConvFromHex(RVA5);
	    m_PEFile.PEHdr.TLSDataSize = ConvFromHex(Size5);
	    m_PEFile.PEHdr.LoadConfigRVA = ConvFromHex(RVA6);
	    m_PEFile.PEHdr.LoadConfigDataSize = ConvFromHex(Size6);
	    m_PEFile.PEHdr.DebugTableRVA = ConvFromHex(RVA7);
	    m_PEFile.PEHdr.DebugDataSize = ConvFromHex(Size7);
	    m_PEFile.PEHdr.ExceptionTableRVA = ConvFromHex(RVA8);
	    m_PEFile.PEHdr.ExceptionDataSize = ConvFromHex(Size8);
	    m_PEFile.PEHdr.FixUpTableRVA = ConvFromHex(RVA9);
	    m_PEFile.PEHdr.FixUpDataSize = ConvFromHex(Size9);
    	m_PEFile.PEHdr.IATRVA = ConvFromHex(RVA10);
    	m_PEFile.PEHdr.IATDataSize = ConvFromHex(Size10);
    	m_PEFile.PEHdr.ImageDescriptionRVA = ConvFromHex(RVA11);
	    m_PEFile.PEHdr.DescriptionDataSize = ConvFromHex(Size11);
	    m_PEFile.PEHdr.MachineSpecificRVA = ConvFromHex(RVA12);
	    m_PEFile.PEHdr.MachnineDataSize = ConvFromHex(Size12);

		m_PEFile.WritePEHeader();

		CDialog::OnOK();
	}
	else CDialog::OnOK();
}

void CDirectoryInfoDlg::OnCancel() 
{
	CDialog::OnCancel();
}
