// ModifyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PEEditor.h"
#include "ModifyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModifyDlg dialog


CModifyDlg::CModifyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CModifyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModifyDlg)
	//}}AFX_DATA_INIT
}


void CModifyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModifyDlg)
	DDX_Control(pDX, IDC_VSIZE, m_VS);
	DDX_Control(pDX, IDC_S_CHR, m_SCH);
	DDX_Control(pDX, IDC_RSIZE, m_RS);
	DDX_Control(pDX, IDC_ROFFSET, m_RO);
	DDX_Control(pDX, IDC_VOFFSET, m_VO);
	DDX_Control(pDX, IDC_S_NAME, m_SName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModifyDlg, CDialog)
	//{{AFX_MSG_MAP(CModifyDlg)
	ON_BN_CLICKED(ID_OK, OnOk)
	ON_BN_CLICKED(ID_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModifyDlg message handlers

BOOL CModifyDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_SName.SetLimitText(7);
	m_VS.SetLimitText(8);
	m_VO.SetLimitText(8);
	m_RS.SetLimitText(8);
	m_RO.SetLimitText(8);
	m_SCH.SetLimitText(8);
	
	SetDlgItemText(IDC_S_NAME,  m_SectionName);
	SetDlgItemText(IDC_VSIZE,   m_VSize);
	SetDlgItemText(IDC_VOFFSET, m_VOffset);
	SetDlgItemText(IDC_RSIZE,   m_RSize);
	SetDlgItemText(IDC_ROFFSET, m_ROffset);
	SetDlgItemText(IDC_S_CHR,   m_Charact);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CModifyDlg::OnOk() 
{
	CString tmp;
	GetDlgItemText(IDC_S_NAME,  tmp);
	strcpy(m_SectionName, tmp);
	GetDlgItemText(IDC_VSIZE,   tmp);
	strcpy(m_VSize, tmp);
	GetDlgItemText(IDC_VOFFSET, tmp);
	strcpy(m_VOffset, tmp);
	GetDlgItemText(IDC_RSIZE,   tmp);
	strcpy(m_RSize, tmp);
	GetDlgItemText(IDC_ROFFSET, tmp);
	strcpy(m_ROffset, tmp);
	GetDlgItemText(IDC_S_CHR,   tmp);
	strcpy(m_Charact, tmp);

	CDialog::OnOK();
}

void CModifyDlg::OnCancel() 
{
	CDialog::OnCancel();
}
